package com.jfinal.club.util;

import org.apache.poi.hssf.usermodel.*;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;

import java.io.FileOutputStream;
import java.text.DecimalFormat;

/**
 * @descriptions:
 * @author: lc
 * @date: 2020-06-28 16:40:05
 * @Version: 1.0
 **/
public class ExcelUtils {


    /**
     * 0 用户名称
     * 1 省份
     * 2 城市
     * 3 公司注册地址
     * 4 授权类型
     * 5 联系人
     * 6 联系电话
     *
     * @param args
     */
    public static void main(String[] args) {
        //获取数据

        //excel标题
        String[] title = {"客户名称", "省份", "城市", "公司注册地址", "授权类型", "联系人", "联系电话"};
        //excel文件名
        String fileName = "用户信息表" + System.currentTimeMillis( ) + ".xls";

        //sheet名
        String sheetName = "用户信息表";

        String[][] content = new String[7][7];


        //创建HSSFWorkbook
        HSSFWorkbook wb = getHSSFWorkbook(sheetName, title, content, null);

        //响应到客户端
        try {
            FileOutputStream out = new FileOutputStream("d://aaa.xls");
            wb.write(out);
            out.flush( );
            out.close( );
        } catch (Exception e) {
            e.printStackTrace( );
        }


    }

    public static HSSFWorkbook getHSSFWorkbook(String sheetName, String[] title, String[][] values, HSSFWorkbook wb) {

        // 第一步，创建一个HSSFWorkbook，对应一个Excel文件
        if (wb == null) {
            wb = new HSSFWorkbook( );
        }

        // 第二步，在workbook中添加一个sheet,对应Excel文件中的sheet
        HSSFSheet sheet = wb.createSheet(sheetName);

        // 第三步，在sheet中添加表头第0行,注意老版本poi对Excel的行数列数有限制
        HSSFRow row = sheet.createRow(0);

        // 第四步，创建单元格，并设置值表头 设置表头居中
        CellStyle style = wb.createCellStyle( );
        style.setAlignment(HSSFCellStyle.ALIGN_LEFT); // 创建一个居中格式
        //声明列对象
        HSSFCell cell = null;

        //创建标题
        for (int i = 0; i < title.length; i++) {
            if (i == 0) {
                sheet.setColumnWidth(i, 30 * 256);
            } else if (i == 1) {
                sheet.setColumnWidth(i, 40 * 256);
            } else if (i == 2) {
                sheet.setColumnWidth(i, 20 * 256);
            } else if (i == 3) {
                sheet.setColumnWidth(i, 20 * 256);
            } else if (i == 4) {
                sheet.setColumnWidth(i, 80 * 256);
            } else if (i == 5) {
                sheet.setColumnWidth(i, 20 * 256);
            }else if (i == 6) {
                sheet.setColumnWidth(i, 20 * 256);
            }
            cell = row.createCell(i);
            cell.setCellValue(title[i]);
            cell.setCellStyle(style);
        }

        //创建内容
        for (int i = 0; i < values.length; i++) {
            row = sheet.createRow(i + 1);
            for (int j = 0; j < values[i].length; j++) {
                //将内容按顺序赋给对应的列对象
                row.createCell(j).setCellValue(values[i][j]);
            }
        }
        return wb;
    }

    public static String getValue(Cell cell) {
        if (cell == null) {
            return "";
        }
        String str;
        DecimalFormat df = new DecimalFormat("0");
        if (cell.getCellType( ) == HSSFCell.CELL_TYPE_BOOLEAN) {
            str = String.valueOf(cell.getBooleanCellValue( ));
            return str;
        } else if (cell.getCellType( ) == HSSFCell.CELL_TYPE_NUMERIC) {
            str = df.format(cell.getNumericCellValue( ));
            return str;
        } else {
            str = cell.getStringCellValue( );
            return str;
        }
    }

}
